#!/bin/sh

###
# Special thanks to James Carpenter for the Slack integration portion
# of this postflight script
# https://gist.github.com/orbsmiv/b9bce468f28134935b491262e948a5f0
###

# 1. Sign-in to your Slack channel at <https://slack.com>
# 2. Follow the instructions here (<https://my.slack.com/services/new/incoming-webhook>) to setup an incoming-webhook (N.B. you will need admin privileges)
# 3. Copy the webhook-token (everything following "https://hooks.slack.com/services/" in the Webhook URL) to the varible below
# 4. Add this script as a postflight script to your CCC backup tasks

webhookToken="T00000000/AAAAAAAAA/ABABABABABABABABABABABABA"
slackUsername="CCC on $(/bin/hostname)"
iconURL="https://bombich.com/software/images/ccc_128.jpg"
fail_channel="#ccc"
success_emoji=":white_check_mark:"
some_errors_emoji=":anguished:"
fail_emoji=":-1:"

# No edits required past this line, unless you wish to further alter the appearance of the Slack message
src="$1"
dest="$2"
status="$3"
dmgPath="$4"

if [ "$status" = "89" ]; then
	# the task was cancelled by the user
	exit 0
elif [ "$status" = "0" ]; then
	result="The backup task completed successfully $success_emoji"
elif [ "$status" = "1050" ]; then
	result="*Some errors occurred* $some_errors_emoji"
	channel="$fail_channel"
else
	result="*The backup task failed* $fail_emoji"
	channel="$fail_channel"
fi

if [ "$dmgPath" = "" ]; then
	text=$( /usr/bin/printf "*%s* –> *%s*\n%s" "$src" "$dest" "$result" )
else
	text=$( /usr/bin/printf "*%s* –> *%s* [%s]\n%s" "$src" "$dest" "$dmgPath" "$result" )
fi

if [ "$channel" = "" ]; then
	data=$( /usr/bin/printf "payload={\"username\": \"%s\", \"text\": \"%s\", \"icon_url\": \"%s\"}" "$slackUsername" "$text" $iconURL )
else
	data=$( /usr/bin/printf "payload={\"username\": \"%s\", \"text\": \"%s\", \"icon_url\": \"%s\", \"channel\": \"%s\"}" "$slackUsername" "$text" $iconURL $channel)
fi

/usr/bin/curl -X POST --data-urlencode "$data" https://hooks.slack.com/services/$webhookToken
